/* filebrowser.hh
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#ifndef GLTK_FILEBROWSER_HH
#define GLTK_FILEBROWSER_HH
#include "box.hh"
#include "listview.hh"
#include <vector>
#include <list>

namespace gltk {
	/** Show files in current directory allowing navigation and selection.
	    The FileBrowser is built with a ListView and a ScrollBar packed in
	    a Box widget.
	    \image html FileBrowser.png */
	class FileBrowser :
		public Box
	{
		ViewableList * list;
	public:
		FileBrowser();
		void set_path(std::string const & path); ///< set the current directory
		std::string get_path() const; ///< get the current directory

		/// signal when a file is selected, pass the name of selected file
		sigc::signal<void, std::string> & signal_selected();
	};
}
#endif
