/* focusable.cc
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include "focusable.hh"
#include "glut_inc.hh"
#include <iostream>
using namespace gltk;

bool Focusable::focus_make()
{
	focused = true;
	queue_draw();
	return true;
}

bool Focusable::focus_next()
{
	focus_end();
	return false;
}

void Focusable::focus_end()
{
	focused = false;
	queue_draw();
}

void Focusable::draw_focus_box()
{
	if (focused) {
		int w = get_width();
		int h = get_height();
		glEnable(GL_LINE_STIPPLE);
		glLineStipple(1, 0x5555);
		glColor3f(0., 0., 0.);
		glBegin(GL_LINE_LOOP);
		glVertex2f(0.5, 0.5);
		glVertex2f(w - 0.5, 0.5);
		glVertex2f(w - 0.5, h - 0.5);
		glVertex2f(0.5, h - 0.5);
		glEnd();
		glDisable(GL_LINE_STIPPLE);
	}
}

Focusable::Focusable() :
	focused(false)
{}
