/* focusable.hh
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#ifndef GLTK_FOCUSABLE_HH
#define GLTK_FOCUSABLE_HH
#include "widget.hh"
namespace gltk {
	/// a Widget that can be focused on.
	class Focusable :
		virtual public Widget
	{
	protected:
		bool focused; ///< the Focusable is focused
		bool focus_make();
		bool focus_next();
		void focus_end();
		virtual void draw_focus_box();
	public:
		Focusable();
	};
}
#endif
