/* frame.cc
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include "frame.hh"
#include "glut_inc.hh"
#include "internal.hh"
#include <iostream>
using namespace gltk;
void Frame::on_configure_event()
{
	Bin::on_configure_event();
	place_bin(3, text_height() + 2);
}

void Frame::on_draw()
{
	draw_children();
	int w = get_width();
	int h = get_height();
	// float htop = (name_h + 2) / 2 + 0.5;
	float htop = 1.5 + get_ascent();
	glColor3f(0.6, 0.6, 0.6);
	glBegin(GL_LINE_LOOP);
	glVertex2f(1.5, htop);
	glVertex2f(w - 1.5, htop);
	glVertex2f(w - 1.5, h - 1.5);
	glVertex2f(1.5, h - 1.5);
	glEnd();
	glColor3f(0, 0, 0);
	glRasterPos2i(1, 1);
	draw_text(ALIGN_START, ALIGN_START, w - 2);
}

Frame::Frame(std::string const & title)
{
	set_text(title);
	set_reserved(6, text_height() + 5);
}
