/* idle.hh
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#ifndef GLTK_IDLE_HH
#define GLTK_IDLE_HH
#include "sigc.hh"
namespace gltk {
	/** calling a slot when system is free
	    SignalIdle provides a system signal that is emitted when the system is idle.
	    Like a regular signal It can be connected to multiple slots. */
	class SignalIdle
	{
	public:
		/** Connects an idle handler.
		    Returning false from the slot will sever the connection. */
		static sigc::connection connect(sigc::slot0<bool> const & slot);
		/// Connects an idle handler that runs only once.
		static void connect_once(sigc::slot0<void> const & slot);
	};
}
#endif
