/* internal.hh
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#ifndef GLTK_MISC_HH
#define GLTK_MISC_HH
#include <string>
// These are internal functions used by gltk
namespace gltk {
	int glut_get_font_height(void * font);
	int glut_get_font_ascent(void * font);
	int glut_get_font_descent(void * font);
	void glut_draw_string(void * font, std::string const & text);
	void glut_draw_string(void * font, std::string const & text, int limit);
	int glut_get_string_width(void * font, std::string const & text);
	void glut_draw_raised_box(int x, int y, int w, int h);
	int glut_raised_box_width();
	void glut_draw_sunken_box(int x, int y, int w, int h);
	int glut_sunken_box_width();
	inline int round_int(double x) {return x > 0 ? int(x + 0.5) : int(x - 0.5);}
	template<typename T>
	inline T min_of(T a, T b) {return a > b ? b : a;}
	template<typename T>
	inline T max_of(T a, T b) {return a > b ? a : b;}
	struct Error
	{
		std::string msg;
		Error(std::string const & s) : msg(s) {}
	};
}
#endif
