/* separator.cc
 * 
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This file is part of gltk.
 * 
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with gltk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include "separator.hh"
#include "glut_inc.hh"

using namespace gltk;

void Separator::on_draw()
{
	int w = get_width();
	int h = get_height();
	glBegin(GL_LINES);
	if (hori) {
		glColor3f(0.8, 0.8, 0.8);
		glVertex2f(0, (h - 1) / 2.0);
		glVertex2f(w, (h - 1) / 2.0);
		glColor3f(1.0, 1.0, 1.0);
		glVertex2f(0, (h + 1) / 2.0);
		glVertex2f(w, (h + 1) / 2.0);
	}
	else {
		glColor3f(0.8, 0.8, 0.8);
		glVertex2f((w - 1) / 2.0, 0);
		glVertex2f((w - 1) / 2.0, h);
		glColor3f(1.0, 1.0, 1.0);
		glVertex2f((w + 1) / 2.0, 0);
		glVertex2f((w + 1) / 2.0, h);
	}
	glEnd();
}

void Separator::get_preferred_width(int & min, int & nat) const
{
	if (hori) {
		min = 0;
		nat = 4;
	}
	else {
		min = 4;
		nat = 4;
	}
}

void Separator::get_preferred_height(int & min, int & nat) const
{
	if (hori) {
		min = 4;
		nat = 4;
	}
	else {
		min = 0;
		nat = 4;
	}
}

Separator::Separator(Orientation orientation) :
	hori(orientation == ORIENTATION_HORIZONTAL)
{
}
